class StandardError
  # Shortcut for .send(:notify_or_ignore, *e.airbrake_args)
  def airbrake_args
    [self, parameters: airbrake_params]
  end

  # Default is to report all instance variables to Airbrake.
  def airbrake_params
    params = {}

    begin
      instance_variables.each do |name|
        params[name.to_s] = instance_variable_get(name).try(:as_json)
      end
    rescue StandardError => e
      # In development or test, complain if this goes wrong.
      # In production, don't crash, omitting params instead.
      # Dear user: If your errors stop showing parameters, this may be why.
      raise e if Rails.env.development?
    end

    params
  end
end
